---
lang: en
title: 'API docs: openapi-spec-builder.openapispecbuilder.withoperation'
keywords: LoopBack 4.0, LoopBack 4, Node.js, TypeScript, OpenAPI
sidebar: lb4_sidebar
editurl: https://github.com/loopbackio/loopback-next/tree/master/packages/openapi-spec-builder
permalink: /doc/en/lb4/apidocs.openapi-spec-builder.openapispecbuilder.withoperation.html
---

<!-- Do not edit this file. It is automatically generated by API Documenter. -->

[Home](./index.md) &gt; [@loopback/openapi-spec-builder](./openapi-spec-builder.md) &gt; [OpenApiSpecBuilder](./openapi-spec-builder.openapispecbuilder.md) &gt; [withOperation](./openapi-spec-builder.openapispecbuilder.withoperation.md)

## OpenApiSpecBuilder.withOperation() method

Define a new OperationObject at the given path and verb (method).

**Signature:**

```typescript
withOperation(verb: string, path: string, spec: OperationObject | OperationSpecBuilder): this;
```

## Parameters

<table><thead><tr><th>

Parameter


</th><th>

Type


</th><th>

Description


</th></tr></thead>
<tbody><tr><td>

verb


</td><td>

string


</td><td>

The HTTP verb.


</td></tr>
<tr><td>

path


</td><td>

string


</td><td>

The path relative to basePath.


</td></tr>
<tr><td>

spec


</td><td>

OperationObject \| [OperationSpecBuilder](./openapi-spec-builder.operationspecbuilder.md)


</td><td>

Additional specification of the operation.


</td></tr>
</tbody></table>
**Returns:**

this


